Bug 1270513 - (newtonsoft-json) Review Request: newtonsoft-json - Popular high-performance JSON framework
Review Request: newtonsoft-json - Popular high-performance JSON framework
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
high Severity medium
: ---
: ---
Assigned To: Claudio Rodrigo Pereyra DIaz
Fedora Extras Quality Assurance
:
Depends On:
Blocks: openra maxmind-db maxmind-geoip2 1285649
  Show dependency treegraph
 
Reported: 2015-10-10 08:38 EDT by Raphael Groner
Modified: 2015-12-28 17:55 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-28 17:55:08 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
claudiorodrigo: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Raphael Groner 2015-10-10 08:38:28 EDT
Spec URL: https://raphgro.fedorapeople.org/review/openra/newtonsoft-json.spec
SRPM URL: https://raphgro.fedorapeople.org/review/openra/newtonsoft-json-7.0.1-1.fc23.src.rpm
Description: Popular high-performance JSON framework
Fedora Account System Username: raphgro

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=11398464
Comment 1 Upstream Release Monitoring 2015-10-10 08:38:45 EDT
raphgro's scratch build of newtonsoft-json-7.0.1-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11398464
Comment 2 Raphael Groner 2015-11-26 05:35:01 EST
Raising priority to high cause newtonsoft-json is needed for several other reviews and an update of MonoDevelop.
Comment 3 Claudio Rodrigo Pereyra DIaz 2015-11-26 10:10:18 EST
Need split pc file into -devel package
Need add:
%dir %{_monodir}/%{name}

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "BSD", "LGPL (v2.1 or later) (with
     incorrect FSF address)", "Unknown or generated". 317 files have
     unknown license. Detailed output of licensecheck in
     /media/galileo/fedora/1270513-newtonsoft-json/licensecheck.txt
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/mono/newtonsoft-json
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/mono/newtonsoft-json
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[!]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[-]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[?]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[!]: The placement of pkgconfig(.pc) files are correct.
     Note: newtonsoft-json : /usr/lib64/pkgconfig/newtonsoft-json.pc
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: newtonsoft-json-7.0.1-1.fc24.x86_64.rpm
          newtonsoft-json-7.0.1-1.fc24.src.rpm
newtonsoft-json.x86_64: E: no-binary
newtonsoft-json.x86_64: W: only-non-binary-in-usr-lib
newtonsoft-json.x86_64: W: devel-file-in-non-devel-package /usr/lib64/pkgconfig/newtonsoft-json.pc
newtonsoft-json.src:40: W: macro-in-comment %{libname}
newtonsoft-json.src:42: W: macro-in-comment %{libname}
newtonsoft-json.src:66: E: hardcoded-library-path in %{buildroot}/usr/lib
2 packages and 0 specfiles checked; 2 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No existe el fichero o el directorio
newtonsoft-json.x86_64: E: no-binary
newtonsoft-json.x86_64: W: only-non-binary-in-usr-lib
newtonsoft-json.x86_64: W: devel-file-in-non-devel-package /usr/lib64/pkgconfig/newtonsoft-json.pc
1 packages and 0 specfiles checked; 1 errors, 2 warnings.



Requires
--------
newtonsoft-json (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    mono(System)
    mono(System.Core)
    mono(System.Data)
    mono(System.Numerics)
    mono(System.Runtime.Serialization)
    mono(System.Xml)
    mono(System.Xml.Linq)
    mono(mscorlib)



Provides
--------
newtonsoft-json:
    mono(Newtonsoft.Json)
    newtonsoft-json
    newtonsoft-json(x86-64)
    pkgconfig(newtonsoft-json)
Comment 4 Upstream Release Monitoring 2015-11-26 12:56:11 EST
raphgro's scratch build of newtonsoft-json-7.0.1-2.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11986801
Comment 5 Raphael Groner 2015-11-26 13:28:09 EST
Hi Claudio,
thanks for your review. May I assign this bug to you as you're doing the official process?

Spec URL: https://raphgro.fedorapeople.org/review/openra/newtonsoft-json.spec
SRPM URL: https://raphgro.fedorapeople.org/review/openra/newtonsoft-json-7.0.1-2.fc23.src.rpm

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=11986801

* Thu Nov 26 2015 Raphael Groner <> - 7.0.1-2
- fix folders ownership
- remove obsolete generation of pkgconfig file

About general discussion of devel subpackages for mono, see bug #477308.
<rant> IMHO it's generally ridiculous to blow up spec files with generation of .pc files that does not bring any real benefit over rpm's own features, but so I tried in first step. Instead, mono is able to resolve its dependencies and there's virtual Provides: mono(Newtonsoft.Json) </rant>

> [?]: Patches link to upstream bugs/comments/lists or are otherwise
>      justified.

That's not needed, both patches are for Fedora only to ensure package builds properly, see the comments.

> [?]: %check is present and all tests pass.

It's present and all enabled tests pass. We've to disable some tests due to in Fedora currently unresolvable dependencies.
Comment 6 Claudio Rodrigo Pereyra DIaz 2015-11-26 14:10:20 EST
(In reply to Raphael Groner from comment #5)
> Hi Claudio,
> thanks for your review. May I assign this bug to you as you're doing the
> official process?
> 
> Spec URL: https://raphgro.fedorapeople.org/review/openra/newtonsoft-json.spec
> SRPM URL:
> https://raphgro.fedorapeople.org/review/openra/newtonsoft-json-7.0.1-2.fc23.
> src.rpm
> 
> Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=11986801
> 
> * Thu Nov 26 2015 Raphael Groner <> - 7.0.1-2
> - fix folders ownership
> - remove obsolete generation of pkgconfig file
> 
> About general discussion of devel subpackages for mono, see bug #477308.
> <rant> IMHO it's generally ridiculous to blow up spec files with generation
> of .pc files that does not bring any real benefit over rpm's own features,
> but so I tried in first step. Instead, mono is able to resolve its
> dependencies and there's virtual Provides: mono(Newtonsoft.Json) </rant>

rpm resolver dependency yes, but without .pc file monodevelop could not reference the assembly in to any project for development propose.

> > [?]: Patches link to upstream bugs/comments/lists or are otherwise
> >      justified.
> 
> That's not needed, both patches are for Fedora only to ensure package builds
> properly, see the comments.
> 
> > [?]: %check is present and all tests pass.
>
> It's present and all enabled tests pass. We've to disable some tests due to
> in Fedora currently unresolvable dependencies.
Comment 7 Raphael Groner 2015-12-16 17:30:40 EST
Honestly, I do not know how to proceed here. Claudio, could you request that wished pkgconfig from upstream, it's the best we can do - we shouldn't rely on downstream fiddling with that.
Comment 8 Claudio Rodrigo Pereyra DIaz 2015-12-17 06:12:30 EST
The best is request to upstream to add the .pc file to the project and the build process.

Meanwhile, you can add .pc file as a Source1 or generate it on the spec, with a comment to reference the upstream request, until it is added.
Comment 9 Raphael Groner 2015-12-17 13:25:01 EST
Spec URL: https://raphgro.fedorapeople.org/review/openra/newtonsoft-json.spec
SRPM URL: https://raphgro.fedorapeople.org/review/openra/newtonsoft-json-7.0.1-3.fc23.src.rpm

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=12225466

%changelog
* Thu Dec 17 2015 Raphael Groner <> - 7.0.1-3
- readd pkgconfig, split into devel subpackage
Comment 10 Raphael Groner 2015-12-17 13:28:04 EST
Upstream issue: https://github.com/JamesNK/Newtonsoft.Json/issues/742
Comment 11 Upstream Release Monitoring 2015-12-17 13:32:28 EST
raphgro's scratch build of newtonsoft-json-7.0.1-3.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12225466
Comment 12 Claudio Rodrigo Pereyra DIaz 2015-12-18 09:40:23 EST
Now, It is OK to me.
Comment 13 Gwyn Ciesla 2015-12-18 11:01:45 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/newtonsoft-json
Comment 14 Fedora Update System 2015-12-18 11:44:55 EST
newtonsoft-json-7.0.1-3.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-8ca4415c01
Comment 15 Fedora Update System 2015-12-19 15:00:09 EST
newtonsoft-json-7.0.1-3.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update newtonsoft-json'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-8ca4415c01
Comment 16 Fedora Update System 2015-12-28 17:55:05 EST
newtonsoft-json-7.0.1-3.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.